<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~import-external-specimen.js" 
	styles="path.css,~../css/reggie-2.css"
>
<style>


#importItemsTable
{
	width: 100%; 
	border-collapse: collapse;
}

#importItemsTable tr.highlight
{
	border-top-width: 1px;
	border-top-style: dotted;
}

#importItemsTable thead
{
	border-bottom-width: 1px;
}

#importItemsTable th
{
	padding: 4px;
}

#importItemsTable td
{
	text-align: center;
	min-width: 4.5em;
}

#importItemsTable tbody td
{
	padding: 1px 2px;
}

#importItemsTable td.icon, #importItemsTable td.import
{
	width: 20px;
	min-width: 20px;
}

#importItemsTable td.valid
{
	text-align: left;
}

.file-data
{
	font-style: italic;
	opacity: 0.5;
}
</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Import externally processed samples" 
		/></p:path>

	<div class="content">
	<form name="reggie" id="wizard" class="wizard">
	
		<div class="step auto-hide" id="step-1">
			<div class="step-no">1</div>
			<div class="step-title">Select items to import</div>
			<div class="step-content">
				<div id="itemTable"></div>
			</div>
		</div>
	
		<div class="step" id="step-2">
			<div class="step-no">2</div>
			<div class="step-title">Import options</div>
			<div class="step-content">
	
				<table class="step-form">
				<tbody>
					<tr>
						<td class="prompt">Operator</td>
						<td class="input">
							<select name="operator" id="operator">
								<option value="CMD">CMD
								<option value="">- Use JSON -
							</option>
						</td>
						<td class="status" id="operator.status"></td>
						<td class="help">
							<span id="operator.message" class="message"></span>
							The external operator. If the <i>Use JSON</i> option is selected 
							the operator information is taken from the JSON file.
						</td>
					</tr>
				</tbody>
				<tbody>
					<tr class="section-header">
						<td colspan="4">FASTQ Import</td>
					</tr>
					<tr>
						<td class="subprompt">Auto-analyze</td>
						<td class="input">
							<label><input type="radio" name="autoAnalyze" id="autoAnalyzeYes" disabled>Yes</label>
							<label><input type="radio" name="autoAnalyze" id="autoAnalyzeNo" disabled>No</label>
						</td>
						<td class="status" id="autoAnalyze.status"></td>
						<td class="help">
							<span id="autoAnalyze.message" class="message"></span>
							If the auto-analyze option is enabled, Reggie will automatically start
							importing the FASTQ files after a successful JSON import.
						</td>
					</tr>
					<tr>
						<td class="subprompt">Protocol</td>
						<td class="input">
							<select name="mergeProtocol" id="mergeProtocol" disabled></select>
						</td>
						<td class="status" id="mergeProtocol.status"></td>
						<td class="help">
							<span id="mergeProtocol.message" class="message"></span>
							Select the protocol used for merging.
						</td>
					</tr>
					<tr>
						<td class="subprompt">Software</td>
						<td class="input">
							<select name="mergeSoftware" id="mergeSoftware" disabled></select>
						</td>
						<td class="status" id="mergeSoftware.status"></td>
						<td class="help">
							<span id="mergeSoftware.message" class="message"></span>
							Select the software to use for merging the FASTQ files.
						</td>
					</tr>
				</tbody>
				<tbody>
					<tr class="section-header">
						<td colspan="4">Open Grid Scheduler</td>
					</tr>
					<tr>
						<td class="subprompt">Open Grid Cluster</td>
						<td class="input">
							<select name="clusters" id="clusters" class="required" disabled></select>
						</td>
						<td class="status" id="clusters.status"></td>
						<td class="help">
							<span id="clusters.message" class="message"></span>
							Select the cluster to use for running the analysis.
						</td>
					</tr>
					<tr>
						<td class="subprompt">Job priority</td>
						<td class="input">
							<select name="priority" id="priority" disabled></select>
						</td>
						<td class="status" id="priority.status"></td>
						<td class="help">
							<span id="priority.message" class="message"></span>
							Select the priority of the analysis jobs.
						</td>
					</tr>
					<tr>
						<td class="subprompt">Auto-confirm</td>
						<td class="input"><input type="checkbox" name="autoConfirm" checked disabled></td>
						<td class="status" id="autoConfirm.status"></td>
						<td class="help">
							<span id="autoConfirm.message" class="message"></span>
							If the FASTQ analysis is successful, with at least 10M reads 
							after trimmomatic and valid fragment size values, it is
							automatically confirmed and alignment is started.
						</td>
					</tr>
					<tr>
						<td class="subprompt">Debug</td>
						<td class="input"><input type="checkbox" name="debug" disabled></td>
						<td class="status" id="debug.status"></td>
						<td class="help">
							<span id="debug.message" class="message"></span>
							When running in debug mode only part of the sequenced data is used and
							temporary files are not removed from the cluster nodes.
						</td>
					</tr>
				</tbody>
				</table>
			</div>
		</div>
	
		<div id="wizard-status"></div>
		<div id="wizard-progress"></div>

		<table class="navigation" id="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" /></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
			<td><base:button id="goregister" title="Register" image="<%=home+"/images/gonext.png"%>" /></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
			<td id="gonext-message" class="message"></td>
		</tr>
		</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>