var Picklist = function()
{
	var picklist = {};
	var debug = 0;
	
	var lysatesIsValid = false;

	// Page initialization
	picklist.initPage = function()
	{
		var pageId = Doc.getPageId();
		if (pageId == 'protocol')
		{
			Buttons.addClickHandler('print-button', Wizard.goPrint);
			
			var url = '../Outtake.servlet?ID='+App.getSessionId();
			url += '&cmd=GetOuttakeInfo';
			url += '&workListId='+Data.int('page-data', 'list-id');
			url += '&useExternalId='+Data.int('page-data', 'use-external-id');
			Wizard.showLoadingAnimation('Loading aliquot information...');
			Wizard.asyncJsonRequest(url, picklist.initializeProtocol);
		}
		else
		{
			Events.addEventHandler('workList', 'change', picklist.worklistOnChange);
			Buttons.addClickHandler('downloadLabelsCsv', picklist.downloadLabels);
			Buttons.addClickHandler('downloadLabelsXlsx', picklist.downloadLabels);
			Buttons.addClickHandler('gocreate', picklist.viewProtocol);

			var url = '../Outtake.servlet?ID='+App.getSessionId();
			url += '&cmd=GetOuttakeWorklists';
			Wizard.showLoadingAnimation('Loading outtake work lists...');
			Wizard.asyncJsonRequest(url, picklist.initializeStep1);
		}
	}

	picklist.initializeStep1 = function(response)
	{
		var frm = document.forms['reggie'];
		var workLists = response.workLists;
		
		var workList = frm.workList;
		if (workLists.length > 0)
		{
			for (var i=0; i < workLists.length; i++)
			{
				var list = workLists[i];
				var name = list.name + ' (' + list.size+(list.parentType?' '+list.parentType : '') + ')';
				var option = new Option(name, list.id);
				option.workList = list;
				workList.options[workList.length] = option;
			}
			Events.sendChangeEvent(workList);
		}
		else
		{
			Wizard.setFatalError('No outtake works lists available for processing.');
			return;
		}
		
		Doc.show('step-1');
		Doc.show('gocreate');
		Doc.show('golabels');
	}
	
	picklist.worklistOnChange = function()
	{
		var frm = document.forms['reggie'];
		var workList = frm.workList[frm.workList.selectedIndex].workList;
		Doc.element('comments').innerHTML = Strings.encodeTags(workList.comments);
	}

	picklist.viewProtocol = function()
	{
		var frm = document.forms['reggie'];
		frm.submit();
	}

	picklist.downloadLabels = function(event)
	{
		var frm = document.forms['reggie'];
		var format = Data.get(event.currentTarget, 'format');

		var url = '../Outtake.servlet?ID='+App.getSessionId();
		url += '&cmd=DownloadLabels';
		url += '&workListId='+frm.workList.value;
		if (frm.useExternalId.checked)
		{
			url += '&useExternalId=1';
		}
		url += '&format='+encodeURIComponent(format);
		location.href = url;
	}

	picklist.initializeProtocol = function(response)
	{
		var html = '';
		
		var list = response.list;
		var needTargetAmount = list.TargetAmount > 0;
		var needTargetVolume = list.TargetVolume > 0;
		
		Doc.element('parentType').innerHTML = Strings.encodeTags(list.parentType);
		if (needTargetAmount)
		{
			Doc.element('targetAmount').innerHTML = Reggie.formatNumber(list.TargetAmount, ' µg', 1);
		}
		else
		{
			Doc.hide('targetAmountSection');
		}
		if (needTargetVolume)
		{
			Doc.element('targetVolume').innerHTML = Reggie.formatNumber(list.TargetVolume, ' µl', 1);
		}
		else
		{
			Doc.hide('targetVolumeSection');
		}
		if (needTargetAmount && needTargetVolume)
		{
			Doc.element('targetConcentration').innerHTML = Reggie.formatNumber(1000 * list.TargetAmount / list.TargetVolume, ' ng/µl', 2);
		}
		else
		{
			Doc.hide('targetConcentrationSection');
		}
		
		var aliquots = response.aliquots;
		var newBoxes = [];
		var lastAliquotBox = -1;
		var lastRow = -1;
		var lastStorageBox = -1;
		var numRows = 0;
		
		for (var aliquotNo = 0; aliquotNo < aliquots.length; aliquotNo++)
		{
			var a = aliquots[aliquotNo];
			var p = a.parent;
			
			var storageBox = p.bioWell ? p.bioWell.bioPlate : { 'name': 'Unknown box', 'id': 0 };
			var aliquotBox = a.bioWell.bioPlate;
			var markNewBox = false;
			var markNewRow = false;
			if (lastAliquotBox != aliquotBox.id)
			{
				newBoxes[newBoxes.length] = Strings.encodeTags(aliquotBox.name);
				lastAliquotBox = aliquotBox.id;
				markNewBox = true;
			}
			var displayFreezer = false;
			if (lastStorageBox != storageBox.id)
			{
				lastStorageBox = storageBox.id;
				displayFreezer = true;
				
			}
			if (lastRow != a.bioWell.row)
			{
				lastRow = a.bioWell.row;
				numRows++;
				markNewRow = true;
			}
			
			if (displayFreezer || markNewBox)
			{
				markNewRow = true;
				var freezer = storageBox.storage;
				
				html += '<tr class="box-row'+(numRows % 2 == 0 ? ' odd-row' : '')+'">';
				html += '<td colspan="4">';
				html += Strings.encodeTags(storageBox.name);
				if (freezer)
				{
					html += '<span class="freezer"> - '+Strings.encodeTags(freezer.name);
					if (freezer.section) html += '; Section ' + Strings.encodeTags(freezer.section);
					if (freezer.tray) html += '; Tray ' + Strings.encodeTags(freezer.tray);
					if (freezer.position) html += '; Position ' + Strings.encodeTags(freezer.position);
					html += '</span>';
				}
				html += '</td>';
				//html += '<td colspan="2" class="leftborder"></td>';
				html += '<td class="leftborder" colspan="2">'+Strings.encodeTags(aliquotBox.name)+'</td>';
				html += '<td class="leftborder"></td>';
				html += '</tr>';
			}
			
			var remarks = [];
			var dilution = {};
			if (a.dilution)
			{
				dilution = a.dilution;
				if (needTargetAmount)
				{
					if (dilution.amount < list.TargetAmount) 
					{
						// Not enough remaining quantity -- take as much as possible
						remarks[remarks.length] = 'Remain: ' + Reggie.formatNumber(dilution.amount, ' µg', 1);
					}
					else if (dilution.amount > list.TargetAmount)
					{
						// Typically happens to avoid taking less than 1µl
						remarks[remarks.length] = 'Large mix: ' + Reggie.formatNumber(dilution.amount, ' µg', 1);
					}
				}
				else if (needTargetVolume)
				{
					if (dilution.volume < list.TargetVolume)
					{
						// Not enough remaining quantity -- take as much as possible
						remarks[remarks.length] = 'Remain: ' + Reggie.formatNumber(dilution.volume, ' µl', 1);
					}
				}
				if (dilution.water < 0)
				{
					// Happens when source concentration is lower that target concentration
					remarks[remarks.length] = 'Conc: ' + Reggie.formatNumber(p.conc, ' ng/µl', 2);
					dilution.water = null;
				}
			}
			else
			{
				if (!p.remainingQuantity) 
				{
					remarks[remarks.length] = 'Remain: unknown';
				}
				else if (!p.NdConc)
				{
					remarks[remarks.length] = 'Conc: unknown';
				}
			}
			
			var rowClass = [];
			if (markNewRow && numRows > 1) rowClass[rowClass.length] = 'new-row';
			if (markNewBox && newBoxes.length > 1) rowClass[rowClass.length] = 'new-box';
			if (newBoxes.length % 2 == 0) rowClass[rowClass.length] = 'odd-box';
			if (numRows % 2 == 0) rowClass[rowClass.length] = 'odd-row';
			
			html += '<tr class="'+rowClass.join(' ')+'">';
			html += '<th>'+Strings.encodeTags(p.name)+'</th>';
			html += '<td class="box">'+picklist.asStorageLocation(p.bioWell, false)+'</td>';
			html += '<td class="volume leftborder">' + (Numbers.formatNumber(dilution.volume, 1) || '-') + '</td>';
			html += '<td class="water">' + (Numbers.formatNumber(dilution.water, 1) || '-') + '</td>';
			html += '<th class="leftborder">'+Strings.encodeTags(a.externalId || a.name)+'</th>';
			html += '<td class="box">'+(a.bioWell.location)+'</td>';
			html += '<td class="leftborder">' + remarks.join(', ') + '</td>';
			html += '</tr>';
		}
		
		Doc.element('newBoxes').innerHTML = newBoxes.join(', ');
		
		Doc.element('aliquot-list').innerHTML = html;
		Doc.show('all-protocol');
	}

	picklist.asStorageLocation = function(well, displayFreezer)
	{
		if (!well) return '';
		var plate = well.bioPlate;
		var location = '';
		if (plate.storage && displayFreezer)
		{
			var storage = plate.storage;
			location += Strings.encodeTags(storage.name);
			if (storage.section) location += '; Section ' + Strings.encodeTags(storage.section);
			if (storage.tray) location += '; Tray ' + Strings.encodeTags(storage.tray);
			if (storage.position) location += '; Position ' + Strings.encodeTags(storage.position);
			location += '<br>';
		}
		location += Strings.encodeTags(plate.name + ' ' + well.location);
		return location;
	}
	
	return picklist;
}();

Doc.onLoad(Picklist.initPage);

